var ag_files_index = 0;
var ag_animation_speed = 'fast';
var ag_resize_error_messages = '';

function atomicon_gallery_init() {
	jQuery('.atomicon-gallery-upload-file').change(function(){
		var count,template;

  		count = jQuery('.atomicon-gallery-upload-file').length;
  		template = jQuery('.atomicon-gallery-upload-file-template' ,jQuery('.atomicon-gallery-upload-files')).html();

		template = template.split('file-0').join('file-'+count);

		jQuery('.atomicon-gallery-upload-files').append(template);

		atomicon_gallery_init();
	});

	setTimeout( function() { jQuery('.updated').fadeOut('slow'); }, 2000 );
}

function get_percent(value, total)
{
	return parseInt((value / total) * 100);
}

function atomicon_gallery_resize()
{
	jQuery('input[name="atomicon-gallery-create-folder"]').val('');
 	jQuery('#btn-resize-process').slideUp(ag_animation_speed);
 	jQuery('#ag-resize-progress-bar').css('width', '0%' );
 	ag_files_index = 0;

 	atomicon_gallery_resize_file();
}

function atomicon_gallery_resize_file()
{
	var percent = get_percent(ag_files_index, ag_files.length);

	jQuery('#ag-resize-progress').show();
	jQuery('#ag-resize-progress-bar').html(percent + '%');
	jQuery('#ag-resize-progress-bar').animate( { width: percent+'%'}, ag_animation_speed);
	jQuery('#ag-resize-progress-bar').show();

 	if (ag_files_index<ag_files.length)
 	{
 		var ag_data = '', file = ag_files[ag_files_index];

   		ag_data += 'ag_file='+escape(file)+'&';
	 	ag_data += jQuery('#atomicon-gallery-form').serialize();

	 	var data = {
			action: 'atomicon_gallery_resize_file',
			ag_data: ag_data
		};

		jQuery.post(ajaxurl+'?page=atomicon-gallery', data, function(response) {
			ag_resize_error_messages += response;
			ag_files_index++;
			atomicon_gallery_resize_file();
		});
 	}
 	else
 	{
 		jQuery('#ag-resize-progress').slideUp(ag_animation_speed);
 		jQuery('#btn-resize-process').slideDown(ag_animation_speed);
 		if (ag_resize_error_messages!='')
 		{
 			alert(ag_resize_error_messages);
		}
		document.location.reload();
 	}
}

function ag_str_replace(search, replace, subject)
{
	return subject.split(search).join(replace);
}

function shorthand_code_boolean(checkbox_id, value, code)
{
	if (jQuery(checkbox_id + ':checked').val())
	{
		if (code.indexOf(value)==-1)
		{
   			code += ' ' + value;
		}
	}
	else
	{
		code = ag_str_replace(value, '', code);
	}
	return code;
}

function shorthand_code_text(text_id, value, code, numeric)
{
	var pos1,pos2,search;
	search = String(value)+'="';
	pos1 = code.indexOf(search);
	if (pos1!=-1)
	{
		pos2 = code.indexOf('"', pos1+search.length);
		if (pos2!=-1)
		{
			code = code.substr(0,pos1) + code.substr(pos2+1);
		}
	}

 	if (jQuery(text_id).val()!='')
	{
		if (numeric)
		{
			var num = parseInt(jQuery(text_id).val());
			if (isNaN(num) || num == 0)
			{
				return code;
			}
		}
		code += (' ' + value + '="'+jQuery(text_id).val()+'"');
 	}

	return code;
}

function construct_shorthand_code()
{
	var code = jQuery('#ag-shc').val();
	var lastbracket = 0;

	lastbracket = code.indexOf(']');
	code = code.substr(0,lastbracket);

	code = shorthand_code_text('#ag-shc-width', 'width', code);
	code = shorthand_code_text('#ag-shc-height', 'height', code);

	code = shorthand_code_text('#ag-shc-class', 'class', code);
	code = shorthand_code_text('#ag-shc-preview', 'preview', code, true);

	//code = shorthand_code_boolean('#ag-shc-hide-folders', 'hide_folders="true"', code);

	//does a gallery dropdown exist?
	if (jQuery("#ag-shc-folder").length > 0) {
		code = shorthand_code_text('#ag-shc-folder', 'folder', code);
	}

	while( code.indexOf('  ') != -1  )
	{
		code = ag_str_replace('  ', ' ', code);
	}

	while(code.substr(-1,1) == ' ')
	{
		code = code.substr(0, code.length-1);
	}

	code += ']';

	jQuery('#ag-shc').val( code );

}

jQuery(document).ready(function() {

	atomicon_gallery_init();

	jQuery('.ag-toolbar').show();
	jQuery('.ag-panel').hide();


	jQuery('.ag-toolbar-button-upload').click(function(event){
  		event.preventDefault();
  		jQuery('.ag-panel').slideUp(ag_animation_speed);
  		jQuery('.ag-panel-upload').slideDown(ag_animation_speed);
	});

	jQuery('.ag-toolbar-button-create-folder').click(function(event){
  		event.preventDefault();
  		jQuery('.ag-panel').slideUp(ag_animation_speed);
  		jQuery('.ag-panel-create-folder').slideDown(ag_animation_speed);
	});

	jQuery('.ag-toolbar-button-shorthand-code').click(function(event){
  		event.preventDefault();
  		jQuery('.ag-panel').slideUp(ag_animation_speed);
  		jQuery('.ag-panel-shorthand-code').slideDown(ag_animation_speed);
	});

	jQuery('.ag-toolbar-button-help').click(function(event){
  		event.preventDefault();
  		jQuery('.ag-panel').slideUp(ag_animation_speed);
  		jQuery('.ag-panel-help').slideDown(ag_animation_speed);
	});

	jQuery('.ag-toolbar-button-resize').click(function(event){
  		event.preventDefault();
  		jQuery('.ag-panel').slideUp(ag_animation_speed);
  		jQuery('.ag-panel-resize').slideDown(ag_animation_speed);
	});

	jQuery('#btn-resize-process').click(function(event){
		event.preventDefault();
		if (typeof ag_files != 'undefined')
		{
      		atomicon_gallery_resize();
		}
	});

	jQuery('#atomicon-gallery-check-all').click(function(event){
		var checked = jQuery('#atomicon-gallery-check-all').is(':checked');
    	jQuery('.atomicon-gallery-checkbox').attr('checked', checked);
	});

	var checked = jQuery('#atomicon-gallery-check-all').is(':checked');
	jQuery('.atomicon-gallery-checkbox').attr('checked', checked);

	jQuery('#atomicon-gallery-delete').click(function(event){

		if(jQuery('.atomicon-gallery-checkbox:checked').length>0)
		{
			var title = jQuery('#atomicon-gallery-delete').attr('title');
			if (confirm(title))
			{
				return true;
			}
		}
		event.preventDefault();
	});



 	//shorthand code

 	jQuery('.ag-shc-element').change(function(event){
  		construct_shorthand_code();
 	});

 	jQuery('.ag-shc-element').click(function(event){
  		construct_shorthand_code();
 	});

 	jQuery('.ag-shc-element').keyup(function(event){
  		construct_shorthand_code();
 	});

 	//lightbox

 	//jQuery('.atomicon-lightbox').lightBox();

});